/**********************************************/
/*   Program rysujacy i odszukujacy droge     */
/*              w labiryncie                  */
/*        W. Bochniak & G. Cyganek            */
/*     1993, AGH, Wydz. IMiR robotyka         */
/**********************************************/

predicates

  run
  menu
  naprzod
  przejscie    (integer,integer,integer,integer)
  podsw        (char,integer,integer,integer,integer)
  zaokraglenie (real,integer)
  wybor_opcji  (char)
  odczyt       (char,integer,integer)
  skrzyzowanie (integer,integer,integer,integer)
  sciezka      (integer,integer,integer)

goal

  run.

clauses

run :-
  makewindow (1,7,15," L A B I R Y N T ",0,0,20,80),
  makewindow (2,7,15," Legenda ",20,0,5,80),
  makewindow (3,112,112," MENU ",6,25,7,30),
  makewindow (4,112,112," Labirynt ver 1.0 ",5,21,9,38),
  nl,
  write ("   Program rysujacy i odszukujacy  "),
  nl,
  write ("        droge w labiryncie         "),
  nl,
  nl,
  write ("      W. Bochniak & G. Cyganek     "),
  nl,
  write (" (R) 1993, AGH, Wydz. IMiR robotyka"),
  readchar (_),
  removewindow,
  menu,
  shiftwindow (2),
  removewindow,
  shiftwindow (3),
  removewindow,
  shiftwindow (1),
  removewindow.

menu :-
  shiftwindow (3),
  cursor (0,0),
  write (" 1 - Rysowanie reczne"),
  nl,
  write (" 2 - Rysowanie automatyczne"),
  nl,
  write (" 3 - Odszukanie drogi"),
  nl,
  write (" 4 - Czyszczenie ekranu"),
  nl,
  write (" 5 - Wyjscie"),
  readchar (Z),
  wybor_opcji (Z).

wybor_opcji ('1') :-
  shiftwindow (2),
  clearwindow,
  write (" <space>  -  pen up/down"),
  nl,
  write (" q        - zatwierdzenie"),
  shiftwindow (1),
  odczyt ('s',0,0),
  fail.
wybor_opcji ('2') :-
  shiftwindow (1),
  clearwindow,
  skrzyzowanie (0,0,10,1),
  fail.
wybor_opcji ('3') :-
  naprzod,
  shiftwindow (2),
  clearwindow,
  write (" Nacisnij jakis klawisz !"),
  readchar (_),
  fail.
wybor_opcji ('4') :-
  shiftwindow (1),
  scroll (0,-1),
  scroll (0,-1),
  scroll (0,-1),
  scroll (0,-1),
  scroll (0,-2),
  scroll (0,-2),
  scroll (0,-2),
  scroll (0,-2),
  scroll (0,-3),
  scroll (0,-3),
  scroll (0,-3),
  scroll (0,-3),
  scroll (0,-4),
  scroll (0,-4),
  scroll (0,-4),
  scroll (0,-4),
  scroll (0,-5),
  scroll (0,-5),
  scroll (0,-10),
  scroll (0,-10),
  scroll (0,-10),
  clearwindow,
  fail.
wybor_opcji ('5').
wybor_opcji (_) :-
  menu.

/****************************************************************************/
/*                            Rysowanie reczne                              */
/****************************************************************************/

odczyt('s',0,0) :-
  !,
  scr_char (0,0,''),
  scr_attr (0,0,132),
  cursor (17,76),
  readchar (Z),
  odczyt (Z,0,0).

odczyt ('6',Xold,Y) :-
  Xold < 76,
  !,
  Xnew = Xold + 1,
  scr_attr (Y,Xold,7),
  scr_attr (Y,Xnew,132),
  scr_char (Y,Xnew,''),
  readchar (Z),
  odczyt (Z,Xnew,Y).

odczyt ('2',X,Yold) :-
  Yold < 17,
  !,
  Ynew = Yold + 1,
  scr_attr (Yold,X,7),
  scr_attr (Ynew,X,132),
  scr_char (Ynew,X,''),
  readchar (Z),
  odczyt (Z,X,Ynew).

odczyt ('4',Xold,Y) :-
  Xold > 0,
  !,
  Xnew = Xold - 1,
  scr_attr (Y,Xold,7),
  scr_attr (Y,Xnew,132),
  scr_char (Y,Xnew,''),
  readchar (Z),
  odczyt (Z,Xnew,Y).

odczyt ('8',X,Yold) :-
  Yold > 0,
  !,
  Ynew = Yold - 1,
  scr_attr (Yold,X,7),
  scr_attr (Ynew,X,132),
  scr_char (Ynew,X,''),
  readchar (Z),
  odczyt (Z,X,Ynew).

odczyt ('q',X,Y) :- 
  !,
  scr_attr (Y,X,7).

odczyt (' ',X,Y) :-
  !,
  podsw (_,X,Y,Xw,Yw),
  scr_char (Yw,Xw,''),
  odczyt (_,Xw,Yw).

odczyt (_,X,Y) :- 
  !,
  readchar (Z),
  odczyt (Z,X,Y).

/****************************************************************************/
/*                        Przesuwanie niemalujace                           */
/****************************************************************************/

podsw ('s',0,0,X1,Y1) :-
  !,
  scr_attr (0,0,120),
  readchar (Z),
  podsw (Z,0,0,X1,Y1).

podsw ('6',Xold,Y,X1,Y1) :-
  Xold < 76,
  !,
  scr_attr (Y,Xold,7),
  Xnew = Xold + 1,
  scr_attr (Y,Xnew,120),
  readchar (Z),
  podsw (Z,Xnew,Y,X1,Y1).

podsw ('2',X,Yold,X1,Y1) :-
  Yold < 17,
  !,
  scr_attr (Yold,X,7),
  Ynew = Yold + 1,
  scr_attr (Ynew,X,120),
  readchar (Z),
  podsw (Z,X,Ynew,X1,Y1).

podsw ('4',Xold,Y,X1,Y1) :-
  Xold > 0,
  !,
  scr_attr (Y,Xold,7),
  Xnew = Xold - 1,
  scr_attr (Y,Xnew,120),
  readchar (Z),
  podsw (Z,Xnew,Y,X1,Y1).

podsw ('8',X,Yold,X1,Y1) :-
  Yold > 0,
  !,
  scr_attr (Yold,X,7),
  Ynew = Yold - 1,
  scr_attr (Ynew,X,120),
  readchar (Z),
  podsw (Z,X,Ynew,X1,Y1).

podsw (' ',X,Y,X,Y) :-
  !,
  scr_attr (Y,X,7).

podsw (_,X,Y,X1,Y1) :-
  !,
  readchar (Z),
  podsw (Z,X,Y,X1,Y1).

/****************************************************************************/
/*                           Odszukiwanie drogi                             */
/****************************************************************************/

naprzod :-
  shiftwindow (2),
  nl,
  nl,
  write (" Ustal punkt startowy ( <space> - zatwierdzenie )."),
  nl,
  shiftwindow (1),
  podsw ('s',0,0,Xp,Yp),
  scr_attr (Yp,Xp,120),
  shiftwindow (2),
  nl,
  write (" Ustal punkt koncowy ( <space> - zatwierdzenie )."),
  nl,
  shiftwindow (1),
  podsw ('s',0,0,Xk,Yk),
  scr_attr (Yp,Xp,120),
  scr_attr (Yk,Xk,120),
  przejscie (Xp,Yp,Xk,Yk).

przejscie (X,Y,X,Y) :-
  scr_char (Y,X,''),
  !,
  sound (5,300),
  sound (5,500),
  sound (5,400),
  sound (5,700),
  sound (5,600),
  sound (5,800).
  
przejscie (X,Y,Xk,Yk) :-
  X >= 0,X <= 76,
  Y >= 0,Y <= 17,
  scr_char (Yk,Xk,V),
  V = '',
  scr_char (Y,X,Z),
  Z = '',
  !,
  sound (5,45),
  scr_char (Y,X,''),
  A = X + 1,
  przejscie (A,Y,Xk,Yk),
  B = X - 1,
  przejscie (B,Y,Xk,Yk),
  C = Y + 1,
  przejscie (X,C,Xk,Yk),
  D = Y - 1,
  przejscie (X,D,Xk,Yk).
przejscie(_,_,_,_).

/****************************************************************************/
/*                    Automatyczne rysowanie drog                           */
/****************************************************************************/

zaokraglenie (R,0) :-
  0 <= R, R <=1.
zaokraglenie (R,0) :-
  1 < R, R <=2.
zaokraglenie (R,0) :-
  2 < R, R <=3.
zaokraglenie (R,3) :-
  3 < R, R <=4.
zaokraglenie (R,4) :-
  4 < R, R <=5.
zaokraglenie (R,5) :-
  5 < R, R <=6.
zaokraglenie (R,6) :-
  6 < R, R <=7.
zaokraglenie (R,0) :-
  R > 7.

sciezka (X,Y,K) :-
  Y >= 0, Y <= 17,
  X >= 0, X <= 76,
  scr_char (Y,X,S),
  S <> '',
  !,
  random (A),
  Pom = A * 20,
  cursor (Y,X),
  write (""),
  zaokraglenie (Pom,Z),
  skrzyzowanie (Z,X,Y,K).
sciezka(_,_,_).  

skrzyzowanie (0,X,Y,1) :- 
  Xnew = X + 1,
  sciezka (Xnew,Y,1).
skrzyzowanie (1,X,Y,1) :-
  Ynew = Y + 1,
  sciezka (X,Ynew,2). 
skrzyzowanie (2,X,Y,1) :- 
  Ynew = Y - 1,
  sciezka (X,Ynew,4).
skrzyzowanie (3,X,Y,1) :- 
  Xnew = X + 1,
  sciezka (Xnew,Y,1),
  Ynew = Y + 1,
  sciezka (X,Ynew,2).
skrzyzowanie (4,X,Y,1) :-
  Xnew = X + 1,
  sciezka (Xnew,Y,1),
  Ynew = Y - 1,
  sciezka (X,Ynew,4).
skrzyzowanie (5,X,Y,1) :-
  Ynew = Y + 1,
  sciezka (X,Ynew,2),
  Ynew = Y - 1,
  sciezka (X,Ynew,4). 
skrzyzowanie (6,X,Y,1) :- 
  Xnew = X + 1,
  sciezka (Xnew,Y,1),
  Ynew = Y + 1,
  sciezka (X,Ynew,2), 
  Ynew = Y - 1,
  sciezka (X,Ynew,4).

skrzyzowanie (0,X,Y,2) :- 
  Ynew = Y + 1,
  sciezka (X,Ynew,2).
skrzyzowanie (1,X,Y,2) :-
  Xnew = X - 1,
  sciezka (Xnew,Y,3). 
skrzyzowanie (2,X,Y,2) :- 
  Xnew = X + 1,
  sciezka (Xnew,Y,1).
skrzyzowanie (3,X,Y,2) :- 
  Ynew = Y + 1,
  sciezka (X,Ynew,2),
  Xnew = X - 1,
  sciezka (Xnew,Y,3).
skrzyzowanie (4,X,Y,2) :-
  Ynew = Y + 1,
  sciezka (X,Ynew,2),
  Xnew = X + 1,
  sciezka (Xnew,Y,1).
skrzyzowanie (5,X,Y,2) :-
  Xnew = X + 1,
  sciezka (Xnew,Y,1),
  Xnew = X - 1,
  sciezka (Xnew,Y,3). 
skrzyzowanie (6,X,Y,2) :- 
  Ynew = Y + 1,
  sciezka (X,Ynew,2),
  Xnew = X - 1,
  sciezka (Xnew,Y,3), 
  Xnew = X + 1,
  sciezka (Xnew,Y,1).
  
skrzyzowanie (0,X,Y,3) :- 
  Xnew = X - 1,
  sciezka (Xnew,Y,3).
skrzyzowanie (1,X,Y,3) :-
  Ynew = Y - 1,
  sciezka (X,Ynew,4). 
skrzyzowanie (2,X,Y,3) :- 
  Ynew = Y + 1,
  sciezka (X,Ynew,2).
skrzyzowanie (3,X,Y,3) :- 
  Xnew = X - 1,
  sciezka (Xnew,Y,3),
  Ynew = Y - 1,
  sciezka (X,Ynew,4).
skrzyzowanie (4,X,Y,3) :-
  Xnew = X - 1,
  sciezka (Xnew,Y,3),
  Ynew = Y + 1,
  sciezka (X,Ynew,2).
skrzyzowanie (5,X,Y,3) :-
  Ynew = Y - 1,
  sciezka (X,Ynew,4),
  Ynew = Y + 1,
  sciezka (X,Ynew,2). 
skrzyzowanie (6,X,Y,3) :- 
  Xnew = X - 1,
  sciezka (Xnew,Y,3),
  Ynew = Y - 1,
  sciezka (X,Ynew,4), 
  Ynew = Y + 1,
  sciezka (X,Ynew,2).

skrzyzowanie (0,X,Y,4) :- 
  Ynew = Y - 1,
  sciezka (X,Ynew,4).
skrzyzowanie (1,X,Y,4) :-
  Xnew = X + 1,
  sciezka (Xnew,Y,1). 
skrzyzowanie (2,X,Y,4) :- 
  Xnew = X - 1,
  sciezka (Xnew,Y,3).
skrzyzowanie (3,X,Y,4) :- 
  Ynew = Y - 1,
  sciezka (X,Ynew,4),
  Xnew = X + 1,
  sciezka (Xnew,Y,1).
skrzyzowanie (4,X,Y,4) :-
  Ynew = Y - 1,
  sciezka (X,Ynew,4),
  Xnew = X - 1,
  sciezka (Xnew,Y,3).
skrzyzowanie (5,X,Y,4) :-
  Xnew = X - 1,
  sciezka (Xnew,Y,3),
  Xnew = X + 1,
  sciezka (Xnew,Y,1). 
skrzyzowanie (6,X,Y,4) :- 
  Ynew = Y - 1,
  sciezka (X,Ynew,4),
  Xnew = X + 1,
  sciezka (Xnew,Y,1), 
  Xnew = X - 1,
  sciezka (Xnew,Y,3).
skrzyzowanie(_,_,_,_).  